
uint32_t GPSshows=0; // bugbug debug
void readGPS(){
    if(GPS_PORT.available() && gps.read(&uBloxData)) {
      attachInterrupt(digitalPinToInterrupt(GPS_SRX), GPS_serialrx_isr, RISING);
      GPS_newData=0;
      rtk.fixType = uBloxData.fixType;
      rtk.numSV = uBloxData.numSV;
      //rtk.pDOP = uBloxData.pDOP;
      rtk.lat1 = uBloxData.lat;
      rtk.lon1 = uBloxData.lon;
  
      //rtk.heading = uBloxData.heading;
      rtk.gSpeed = uBloxData.gSpeed;
      rtk.hMSL = uBloxData.hMSL;
      rtk.velN = uBloxData.velN;
      rtk.velE = uBloxData.velE;
      rtk.velD = uBloxData.velD;
      // Calculate utcTime for this loop iteration
      rtk.utcTime = ((uBloxData.utcHour)*60.0f*60.0f +
              (uBloxData.utcMin) *60.0f +
              (uBloxData.utcSec) +
              (uBloxData.utcNano)/1000000000.0);
      rtk.upDated = true;
      debugGPS( );
    } else {
      //rtk.utcTime = 0.0f;
      //rtk.lat1 = 0.0f;
      //rtk.lon1 = 0.0f;
      //rtk.upDated = false;
    }
}


#ifdef coutD
void debugGPS( )
{
  static int GPSHz = 0;
  static int gMiss = 0;
  static unsigned char lastT = 'a';
    if(rtk.upDated){
      GPSHz++;
      if ( lastT != uBloxData.utcSec ) {
        coutD.print( "\n-----\t" );
        if ( 5 >= GPSHz ) {
          gMiss++;
          coutD.print( gMiss );
          coutD.print( "  -------------------------------------------\t" );
        }
        GPSHz = 1;
        Dtime( 11, 0, 0 );
      }
      else
        coutD.print( "\t" );

      lastT = uBloxData.utcSec;
      coutD.print( "\t @" );
      coutD.print( uBloxData.utcHour);
      coutD.print( ":" );
      coutD.print( uBloxData.utcMin);
      coutD.print( "." );
      coutD.print( uBloxData.utcSec);
      coutD.print( "_" );
      coutD.print( uBloxData.utcNano);

      coutD.print( " >> " );
      coutD.print( GPSHz ); 
      coutD.print( "==" );
      coutD.print( "\t ms_" );
      coutD.println( Dtime( 11, 2, 0 )/1000 );
    }
}
#else
void debugGPS() {}
#endif

